Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.Designer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.Designer.cs	(revision 9728)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.Designer.cs	(revision 9730)
@@ -30,4 +30,7 @@
       this.partialSizeTextBox = new System.Windows.Forms.TextBox();
       this.completeSizeTextBox = new System.Windows.Forms.TextBox();
+      this.toolStrip = new System.Windows.Forms.ToolStrip();
+      this.analyzeToolStripButton = new System.Windows.Forms.ToolStripDropDownButton();
+      this.toolStrip.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -35,5 +38,5 @@
       // 
       this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 10);
+      this.label1.Location = new System.Drawing.Point(3, 60);
       this.label1.Name = "label1";
       this.label1.Size = new System.Drawing.Size(64, 13);
@@ -44,5 +47,5 @@
       // 
       this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(3, 42);
+      this.label2.Location = new System.Drawing.Point(3, 92);
       this.label2.Name = "label2";
       this.label2.Size = new System.Drawing.Size(108, 13);
@@ -53,5 +56,5 @@
       // 
       this.label3.AutoSize = true;
-      this.label3.Location = new System.Drawing.Point(3, 74);
+      this.label3.Location = new System.Drawing.Point(3, 124);
       this.label3.Name = "label3";
       this.label3.Size = new System.Drawing.Size(123, 13);
@@ -63,5 +66,5 @@
       this.cacheSizeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.cacheSizeTextBox.Location = new System.Drawing.Point(132, 7);
+      this.cacheSizeTextBox.Location = new System.Drawing.Point(132, 57);
       this.cacheSizeTextBox.Name = "cacheSizeTextBox";
       this.cacheSizeTextBox.ReadOnly = true;
@@ -73,5 +76,5 @@
       this.partialSizeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.partialSizeTextBox.Location = new System.Drawing.Point(132, 39);
+      this.partialSizeTextBox.Location = new System.Drawing.Point(132, 89);
       this.partialSizeTextBox.Name = "partialSizeTextBox";
       this.partialSizeTextBox.ReadOnly = true;
@@ -83,5 +86,5 @@
       this.completeSizeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.completeSizeTextBox.Location = new System.Drawing.Point(132, 71);
+      this.completeSizeTextBox.Location = new System.Drawing.Point(132, 121);
       this.completeSizeTextBox.Name = "completeSizeTextBox";
       this.completeSizeTextBox.ReadOnly = true;
@@ -89,8 +92,26 @@
       this.completeSizeTextBox.TabIndex = 5;
       // 
+      // toolStrip
+      // 
+      this.toolStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.analyzeToolStripButton});
+      this.toolStrip.Location = new System.Drawing.Point(0, 0);
+      this.toolStrip.Name = "toolStrip";
+      this.toolStrip.Size = new System.Drawing.Size(486, 25);
+      this.toolStrip.TabIndex = 6;
+      // 
+      // analyzeToolStripButton
+      // 
+      this.analyzeToolStripButton.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
+      this.analyzeToolStripButton.ImageTransparentColor = System.Drawing.Color.Magenta;
+      this.analyzeToolStripButton.Name = "analyzeToolStripButton";
+      this.analyzeToolStripButton.Size = new System.Drawing.Size(61, 22);
+      this.analyzeToolStripButton.Text = "Analyze";
+      // 
       // PermutationSolutionDictionaryView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.toolStrip);
       this.Controls.Add(this.completeSizeTextBox);
       this.Controls.Add(this.partialSizeTextBox);
@@ -100,5 +121,7 @@
       this.Controls.Add(this.label1);
       this.Name = "PermutationSolutionDictionaryView";
-      this.Size = new System.Drawing.Size(486, 98);
+      this.Size = new System.Drawing.Size(486, 175);
+      this.toolStrip.ResumeLayout(false);
+      this.toolStrip.PerformLayout();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -114,4 +137,6 @@
     private System.Windows.Forms.TextBox partialSizeTextBox;
     private System.Windows.Forms.TextBox completeSizeTextBox;
+    private System.Windows.Forms.ToolStrip toolStrip;
+    private System.Windows.Forms.ToolStripDropDownButton analyzeToolStripButton;
   }
 }