Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 9740)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 9741)
@@ -97,5 +97,4 @@
 		{4FE983A1-AAF8-4977-B9E2-52B3224510CB} = {4FE983A1-AAF8-4977-B9E2-52B3224510CB}
 		{8C426FA3-6614-412C-B669-BCE58DB9710E} = {8C426FA3-6614-412C-B669-BCE58DB9710E}
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71} = {6410BDA6-3641-42B2-BABA-AA626E2F6F71}
 		{068C70A7-8CAF-4AB6-8721-4564D62292BC} = {068C70A7-8CAF-4AB6-8721-4564D62292BC}
 		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A} = {3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}
@@ -125,5 +124,4 @@
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8} = {88B9B0E3-344E-4196-82A3-0F9732506FE8}
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295} = {AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0} = {D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}
 		{C9CF6AE8-4637-4A75-9141-042F479B5D50} = {C9CF6AE8-4637-4A75-9141-042F479B5D50}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {A9E282EA-180F-4233-B809-AEDF0787545C}
@@ -234,8 +232,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.Views-3.3", "HeuristicLab.Problems.ExternalEvaluation.Views\3.3\HeuristicLab.Problems.ExternalEvaluation.Views-3.3.csproj", "{3081630C-9521-47D7-8075-1777C12F212C}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.VehicleRouting-3.3", "HeuristicLab.Problems.VehicleRouting\3.3\HeuristicLab.Problems.VehicleRouting-3.3.csproj", "{6410BDA6-3641-42B2-BABA-AA626E2F6F71}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.VehicleRouting.Views-3.3", "HeuristicLab.Problems.VehicleRouting.Views\3.3\HeuristicLab.Problems.VehicleRouting.Views-3.3.csproj", "{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Common-3.3", "HeuristicLab.Clients.Common\3.3\HeuristicLab.Clients.Common-3.3.csproj", "{730A9104-D4D1-4360-966B-E49B7571DDA3}"
@@ -1004,28 +998,4 @@
 		{3081630C-9521-47D7-8075-1777C12F212C}.Release|x86.ActiveCfg = Release|x86
 		{3081630C-9521-47D7-8075-1777C12F212C}.Release|x86.Build.0 = Release|x86
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|x64.ActiveCfg = Debug|x64
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|x64.Build.0 = Debug|x64
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|x86.ActiveCfg = Debug|x86
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|x86.Build.0 = Debug|x86
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Release|Any CPU.Build.0 = Release|Any CPU
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Release|x64.ActiveCfg = Release|x64
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Release|x64.Build.0 = Release|x64
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Release|x86.ActiveCfg = Release|x86
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Release|x86.Build.0 = Release|x86
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Debug|x64.ActiveCfg = Debug|x64
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Debug|x64.Build.0 = Debug|x64
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Debug|x86.ActiveCfg = Debug|x86
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Debug|x86.Build.0 = Debug|x86
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Release|Any CPU.Build.0 = Release|Any CPU
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Release|x64.ActiveCfg = Release|x64
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Release|x64.Build.0 = Release|x64
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Release|x86.ActiveCfg = Release|x86
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0}.Release|x86.Build.0 = Release|x86
 		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1860,7 +1830,3 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(NestedProjects) = preSolution
-		{D1386FE7-682D-4E18-8C4F-CFD423FA5DD0} = {7EB6A587-BD45-40F2-BB15-4A69677A326C}
-		{6410BDA6-3641-42B2-BABA-AA626E2F6F71} = {7EB6A587-BD45-40F2-BB15-4A69677A326C}
-	EndGlobalSection
 EndGlobal
Index: /trunk/sources/HeuristicLab.ExtLibs.sln
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs.sln	(revision 9740)
+++ /trunk/sources/HeuristicLab.ExtLibs.sln	(revision 9741)
@@ -23,6 +23,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ProtobufCS-2.4.1.473", "HeuristicLab.ExtLibs\HeuristicLab.ProtobufCS\2.4.1\HeuristicLab.ProtobufCS\HeuristicLab.ProtobufCS-2.4.1.473.csproj", "{236459CE-80CF-4991-972F-DE74C826BCCC}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ALGLIB-3.6.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.6.0\HeuristicLab.ALGLIB-3.6.0\HeuristicLab.ALGLIB-3.6.0.csproj", "{571A0EE4-C86A-40A6-8790-DA754D464EDC}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "LibSVM-3.12", "HeuristicLab.ExtLibs\HeuristicLab.LibSVM\3.12\LibSVM-3.12\LibSVM-3.12.csproj", "{4C41E3A3-B2FD-46EA-98FB-F21433E58FBE}"
 EndProject
@@ -42,6 +40,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ALGLIB-3.7.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.7.0\HeuristicLab.ALGLIB-3.7.0\HeuristicLab.ALGLIB-3.7.0.csproj", "{6F1D7847-D610-4E52-A184-405DAEFA41A9}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ALGLIB-3.6.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.6.0\ALGLIB-3.6.0\ALGLIB-3.6.0.csproj", "{D863807E-4774-455E-85A4-96E7E6A8F68F}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "EPPlus-3.1.3", "HeuristicLab.ExtLibs\HeuristicLab.EPPlus\3.1.3\EPPlus-3.1.3\EPPlus-3.1.3.csproj", "{7B288026-5502-4A39-BF41-77E086F3E4A3}"
@@ -155,16 +151,4 @@
 		{236459CE-80CF-4991-972F-DE74C826BCCC}.Release|x86.ActiveCfg = Release|x86
 		{236459CE-80CF-4991-972F-DE74C826BCCC}.Release|x86.Build.0 = Release|x86
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Debug|x64.ActiveCfg = Debug|x64
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Debug|x64.Build.0 = Debug|x64
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Debug|x86.ActiveCfg = Debug|x86
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Debug|x86.Build.0 = Debug|x86
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Release|Any CPU.Build.0 = Release|Any CPU
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Release|x64.ActiveCfg = Release|x64
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Release|x64.Build.0 = Release|x64
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Release|x86.ActiveCfg = Release|x86
-		{571A0EE4-C86A-40A6-8790-DA754D464EDC}.Release|x86.Build.0 = Release|x86
 		{4C41E3A3-B2FD-46EA-98FB-F21433E58FBE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{4C41E3A3-B2FD-46EA-98FB-F21433E58FBE}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -275,16 +259,4 @@
 		{6F1D7847-D610-4E52-A184-405DAEFA41A9}.Release|x86.ActiveCfg = Release|x86
 		{6F1D7847-D610-4E52-A184-405DAEFA41A9}.Release|x86.Build.0 = Release|x86
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Debug|x64.ActiveCfg = Debug|x64
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Debug|x64.Build.0 = Debug|x64
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Debug|x86.ActiveCfg = Debug|x86
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Debug|x86.Build.0 = Debug|x86
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Release|Any CPU.Build.0 = Release|Any CPU
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Release|x64.ActiveCfg = Release|x64
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Release|x64.Build.0 = Release|x64
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Release|x86.ActiveCfg = Release|x86
-		{D863807E-4774-455E-85A4-96E7E6A8F68F}.Release|x86.Build.0 = Release|x86
 		{7B288026-5502-4A39-BF41-77E086F3E4A3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{7B288026-5502-4A39-BF41-77E086F3E4A3}.Debug|Any CPU.Build.0 = Debug|Any CPU