Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj	(revision 9721)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj	(revision 9742)
@@ -116,4 +116,10 @@
     <Compile Include="ExpFitting.cs" />
     <Compile Include="IFitting.cs" />
+    <Compile Include="InfoBox.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="InfoBox.Designer.cs">
+      <DependentUpon>InfoBox.cs</DependentUpon>
+    </Compile>
     <Compile Include="LinearLeastSquaresFitting.cs" />
     <Compile Include="LogFitting.cs" />
@@ -155,4 +161,5 @@
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
+    <EmbeddedResource Include="InfoResources\StatisticalTestsInfo.rtf" />
     <None Include="Plugin.cs.frame" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
@@ -168,4 +175,5 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="StatisticalTestsInfo.rtf" />
     <None Include="VS2008ImageLibrary_Annotations_Default.png" />
   </ItemGroup>
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/InfoBox.Designer.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/InfoBox.Designer.cs	(revision 9742)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/InfoBox.Designer.cs	(revision 9742)
@@ -0,0 +1,99 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core.Views {
+  partial class InfoBox {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.okButton = new System.Windows.Forms.Button();
+      this.infoRichTextBox = new System.Windows.Forms.RichTextBox();
+      this.SuspendLayout();
+      // 
+      // okButton
+      // 
+      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Location = new System.Drawing.Point(549, 309);
+      this.okButton.Name = "okButton";
+      this.okButton.Size = new System.Drawing.Size(75, 23);
+      this.okButton.TabIndex = 0;
+      this.okButton.Text = "&OK";
+      this.okButton.UseVisualStyleBackColor = true;
+      this.okButton.Click += new System.EventHandler(this.okButton_Click);
+      // 
+      // infoRichTextBox
+      // 
+      this.infoRichTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.infoRichTextBox.BackColor = System.Drawing.SystemColors.Info;
+      this.infoRichTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
+      this.infoRichTextBox.Location = new System.Drawing.Point(12, 12);
+      this.infoRichTextBox.Name = "infoRichTextBox";
+      this.infoRichTextBox.ReadOnly = true;
+      this.infoRichTextBox.Size = new System.Drawing.Size(612, 291);
+      this.infoRichTextBox.TabIndex = 1;
+      this.infoRichTextBox.Text = "";
+      // 
+      // InfoBox
+      // 
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.ClientSize = new System.Drawing.Size(636, 344);
+      this.Controls.Add(this.infoRichTextBox);
+      this.Controls.Add(this.okButton);
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
+      this.Name = "InfoBox";
+      this.ShowIcon = false;
+      this.ShowInTaskbar = false;
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
+      this.Text = "Info Box";
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button okButton;
+    protected System.Windows.Forms.RichTextBox infoRichTextBox;
+  }
+}
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/InfoBox.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/InfoBox.cs	(revision 9742)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/InfoBox.cs	(revision 9742)
@@ -0,0 +1,77 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.IO;
+using System.Reflection;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Core.Views {
+  public partial class InfoBox : Form {
+    public string Caption {
+      get { return this.Text; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(x => this.Caption = x), value);
+        else
+          this.Text = value;
+      }
+    }
+
+    protected string embeddedResourceName;
+    public string EmbeddedResourceName {
+      get { return embeddedResourceName; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(x => this.EmbeddedResourceName = x), value);
+        else {
+          embeddedResourceName = value;
+          LoadEmbeddedResource(embeddedResourceName);
+        }
+      }
+    }
+
+    public InfoBox() {
+      InitializeComponent();
+    }
+
+    public InfoBox(string caption, string embeddedResourceName)
+      : this() {
+      Caption = caption;
+      EmbeddedResourceName = embeddedResourceName;
+    }
+
+    protected virtual void LoadEmbeddedResource(string name) {
+      Assembly assembly = Assembly.GetCallingAssembly();
+      try {
+        using (Stream stream = assembly.GetManifestResourceStream(name))
+          infoRichTextBox.LoadFile(stream, RichTextBoxStreamType.RichText);
+      }
+      catch (Exception ex) {
+        infoRichTextBox.Text = "Error: Could not load info text. Exception is: " + Environment.NewLine + ex.ToString();
+      }
+    }
+
+    protected virtual void okButton_Click(object sender, EventArgs e) {
+      Close();
+    }
+  }
+}
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/SampleSizeInfluenceView.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/SampleSizeInfluenceView.cs	(revision 9721)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/SampleSizeInfluenceView.cs	(revision 9742)
@@ -161,5 +161,5 @@
 
     private void UpdateCaption() {
-      Caption = Content != null ? Content.OptimizerName + " Box Plots" : ViewAttribute.GetViewName(GetType());
+      Caption = Content != null ? Content.OptimizerName + " Sample Size Influences" : ViewAttribute.GetViewName(GetType());
     }
 
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.cs	(revision 9721)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.cs	(revision 9742)
@@ -280,5 +280,5 @@
 
     private void infoLabel_DoubleClick(object sender, EventArgs e) {
-      using (TextDialog dialog = new TextDialog("Description of statistical tests", toolTip1.GetToolTip(this.infoLabel), true)) {
+      using (InfoBox dialog = new InfoBox("Description of statistical tests", typeof(StatisticalTestingView).Namespace + ".InfoResources.StatisticalTestsInfo.rtf")) {
         dialog.ShowDialog(this);
       }
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.designer.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.designer.cs	(revision 9721)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.designer.cs	(revision 9742)
@@ -65,4 +65,7 @@
       this.splitContainer3 = new System.Windows.Forms.SplitContainer();
       this.pairwiseTestGroupBox = new System.Windows.Forms.GroupBox();
+      this.label3 = new System.Windows.Forms.Label();
+      this.equalDistsTextBox = new System.Windows.Forms.TextBox();
+      this.pairwiseCheckDataButton = new System.Windows.Forms.Button();
       this.label2 = new System.Windows.Forms.Label();
       this.groupCompComboBox = new System.Windows.Forms.ComboBox();
@@ -72,7 +75,4 @@
       this.normalityLabel = new System.Windows.Forms.Label();
       this.selectDataGroupBox = new System.Windows.Forms.GroupBox();
-      this.pairwiseCheckDataButton = new System.Windows.Forms.Button();
-      this.equalDistsTextBox = new System.Windows.Forms.TextBox();
-      this.label3 = new System.Windows.Forms.Label();
       this.contextMenuStrip1.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
@@ -228,5 +228,5 @@
       this.infoLabel.Size = new System.Drawing.Size(16, 16);
       this.infoLabel.TabIndex = 17;
-      this.toolTip1.SetToolTip(this.infoLabel, resources.GetString("infoLabel.ToolTip"));
+      this.toolTip1.SetToolTip(this.infoLabel, "Double click for help");
       this.infoLabel.DoubleClick += new System.EventHandler(this.infoLabel_DoubleClick);
       // 
@@ -293,4 +293,32 @@
       this.pairwiseTestGroupBox.Text = "4. Pairwise Statistical Testing";
       // 
+      // label3
+      // 
+      this.label3.AutoSize = true;
+      this.label3.Location = new System.Drawing.Point(9, 90);
+      this.label3.Name = "label3";
+      this.label3.Size = new System.Drawing.Size(74, 13);
+      this.label3.TabIndex = 18;
+      this.label3.Text = "Equal Groups:";
+      this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
+      // 
+      // equalDistsTextBox
+      // 
+      this.equalDistsTextBox.Location = new System.Drawing.Point(95, 87);
+      this.equalDistsTextBox.Name = "equalDistsTextBox";
+      this.equalDistsTextBox.ReadOnly = true;
+      this.equalDistsTextBox.Size = new System.Drawing.Size(149, 20);
+      this.equalDistsTextBox.TabIndex = 18;
+      // 
+      // pairwiseCheckDataButton
+      // 
+      this.pairwiseCheckDataButton.Location = new System.Drawing.Point(6, 52);
+      this.pairwiseCheckDataButton.Name = "pairwiseCheckDataButton";
+      this.pairwiseCheckDataButton.Size = new System.Drawing.Size(92, 23);
+      this.pairwiseCheckDataButton.TabIndex = 19;
+      this.pairwiseCheckDataButton.Text = "Check Data";
+      this.pairwiseCheckDataButton.UseVisualStyleBackColor = true;
+      this.pairwiseCheckDataButton.Click += new System.EventHandler(this.pairwiseCheckDataButton_Click);
+      // 
       // label2
       // 
@@ -371,32 +399,4 @@
       this.selectDataGroupBox.TabStop = false;
       this.selectDataGroupBox.Text = "1. Select Data";
-      // 
-      // pairwiseCheckDataButton
-      // 
-      this.pairwiseCheckDataButton.Location = new System.Drawing.Point(6, 52);
-      this.pairwiseCheckDataButton.Name = "pairwiseCheckDataButton";
-      this.pairwiseCheckDataButton.Size = new System.Drawing.Size(92, 23);
-      this.pairwiseCheckDataButton.TabIndex = 19;
-      this.pairwiseCheckDataButton.Text = "Check Data";
-      this.pairwiseCheckDataButton.UseVisualStyleBackColor = true;
-      this.pairwiseCheckDataButton.Click += new System.EventHandler(this.pairwiseCheckDataButton_Click);
-      // 
-      // equalDistsTextBox
-      // 
-      this.equalDistsTextBox.Location = new System.Drawing.Point(95, 87);
-      this.equalDistsTextBox.Name = "equalDistsTextBox";
-      this.equalDistsTextBox.ReadOnly = true;
-      this.equalDistsTextBox.Size = new System.Drawing.Size(149, 20);
-      this.equalDistsTextBox.TabIndex = 18;
-      // 
-      // label3
-      // 
-      this.label3.AutoSize = true;
-      this.label3.Location = new System.Drawing.Point(9, 90);
-      this.label3.Name = "label3";
-      this.label3.Size = new System.Drawing.Size(74, 13);
-      this.label3.TabIndex = 18;
-      this.label3.Text = "Equal Groups:";
-      this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
       // 
       // StatisticalTestingView
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.resx
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.resx	(revision 9721)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.resx	(revision 9742)
@@ -188,22 +188,3 @@
     <value>17, 17</value>
   </metadata>
-  <data name="infoLabel.ToolTip" xml:space="preserve">
-    <value>This view offers tools for statistical analysis. 
-
-Check for normality of the data is done using the Jarque-Bera test.
-It requires a sample size of at least 5 samples. 
-
-Statistical hypothesis testing between all groups is performed using the Kruskal-Wallis test. 
-
-For pairwise comparision of the groups the Mann-Whitney U test is used. 
-It also requires sample sizes of at least 5 samples.
-
-The p-values calculated by the statistical tests are interpreted as follows:
-The null hypothesis states that the groups which are compared have the same distribution.
-A p-value &lt; 0.05 (this value is often chosen as significance level)  means the null hypothesis is rejected, 
-which therefore means that the distributions are not equal. 
-
-For the pariwise statistical test, in addition to the p-value, Cohen's d and Hedges' g are calculated.
-According to Wikipedia, these values can be interpreted as follows: "A lower Cohen's d indicates a necessity of larger sample sizes, and vice versa."</value>
-  </data>
 </root>