Index: branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/MatlabParameterOptimizationProblem.cs
===================================================================
--- branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/MatlabParameterOptimizationProblem.cs	(revision 9715)
+++ branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/MatlabParameterOptimizationProblem.cs	(revision 9748)
@@ -28,10 +28,10 @@
 
 namespace HeuristicLab.Problems.ExternalEvaluation.Matlab {
-  [Item("Matlab Parameter Optimization Problem", "Optimization of a parameter vector which is evaluated in Matlab.")]
+  [Item("MATLAB Parameter Optimization Problem", "Optimization of a parameter vector which is evaluated in MATLAB.")]
   [StorableClass]
   [Creatable("Problems")]
   public class MatlabParameterOptimizationProblem : ParameterOptimizationProblem {
     private const string QualityVariableParameterName = "QualityVariableName";
-    private const string MatlabEvaluationScriptParameterName = "MatlabEvaluationScript";
+    private const string MatlabEvaluationScriptParameterName = "MATLABEvaluationScript";
 
     #region parameters
@@ -65,8 +65,8 @@
     public MatlabParameterOptimizationProblem()
       : base(new MatlabParameterVectorEvaluator()) {
-      Parameters.Add(new FixedValueParameter<StringValue>(QualityVariableParameterName, "The name of the quality variable of the SciLab script.", new StringValue("quality")));
-      Parameters.Add(new FixedValueParameter<TextFileValue>(MatlabEvaluationScriptParameterName, "The path to the Matlab evaluation script.", new TextFileValue()));
+      Parameters.Add(new FixedValueParameter<StringValue>(QualityVariableParameterName, "The name of the quality variable of the MATLAB script.", new StringValue("quality")));
+      Parameters.Add(new FixedValueParameter<TextFileValue>(MatlabEvaluationScriptParameterName, "The path to the MATLAB evaluation script.", new TextFileValue()));
 
-      MatlabEvaluationScript.FileDialogFilter = @"Matlab Scripts|*.m|All files|*.*";
+      MatlabEvaluationScript.FileDialogFilter = @"MATLAB Scripts|*.m|All files|*.*";
     }
   }
Index: branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/MatlabParameterVectorEvaluator.cs
===================================================================
--- branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/MatlabParameterVectorEvaluator.cs	(revision 9715)
+++ branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/MatlabParameterVectorEvaluator.cs	(revision 9748)
@@ -30,9 +30,9 @@
 
 namespace HeuristicLab.Problems.ExternalEvaluation.Matlab {
-  [Item("MatLabParameterVectorEvaluator", "An evaluator which takes a parameter vector and returns a quality value, calculated by a Scilab script.")]
+  [Item("MATLABParameterVectorEvaluator", "An evaluator which takes a parameter vector and returns a quality value, calculated by a Scilab script.")]
   [StorableClass]
   public sealed class MatlabParameterVectorEvaluator : ParameterVectorEvaluator {
     private const string QualityVariableParameterName = "QualityVariableName";
-    private const string MatlabEvaluationScriptParameterName = "MatlabEvaluationScript";
+    private const string MatlabEvaluationScriptParameterName = "MATLABEvaluationScript";
     private const string InitializationScriptParameterName = "InitializationScript";
 
@@ -64,12 +64,7 @@
     public MatlabParameterVectorEvaluator()
       : base() {
-      Parameters.Add(new LookupParameter<StringValue>(QualityVariableParameterName, "The name of the quality variable of the Matlab script."));
-      Parameters.Add(new LookupParameter<TextFileValue>(MatlabEvaluationScriptParameterName, "The path to the Matlab evaluation script."));
-      Parameters.Add(new FixedValueParameter<TextFileValue>(InitializationScriptParameterName, "The path to a Matlab script the should be execute before the evaluation starts.", new TextFileValue()));
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      InitializeState();
+      Parameters.Add(new LookupParameter<StringValue>(QualityVariableParameterName, "The name of the quality variable calculated in the MATLAB script."));
+      Parameters.Add(new LookupParameter<TextFileValue>(MatlabEvaluationScriptParameterName, "The path to the MATLAB evaluation script."));
+      Parameters.Add(new FixedValueParameter<TextFileValue>(InitializationScriptParameterName, "The path to a MATLAB script the should be execute before the evaluation starts.", new TextFileValue()));
     }
 
@@ -89,5 +84,6 @@
 
       string initScript = InitializationScript.Value;
-      string result = matLabConnector.Execute("cd " + Path.GetDirectoryName(initScript));
+      var directoryName = Path.GetDirectoryName(initScript);
+      string result = matLabConnector.Execute(string.Format("cd '{0}'", directoryName));
       if (!string.IsNullOrEmpty(result)) throw new InvalidOperationException(result);
 
@@ -110,9 +106,12 @@
 
       lock (locker) {
+        if (matLabConnector == null) InitializeState();
+
         string result;
         string script = evaluationScript.Value;
 
         if (!changedDirectory) {
-          result = matLabConnector.Execute("cd " + Path.GetDirectoryName(script));
+          var directoryName = Path.GetDirectoryName(script);
+          result = matLabConnector.Execute(string.Format("cd '{0}'", directoryName));
           if (!string.IsNullOrEmpty(result)) throw new InvalidOperationException(result);
           changedDirectory = true;
Index: branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/Plugin.cs.frame
===================================================================
--- branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/Plugin.cs.frame	(revision 9715)
+++ branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/Plugin.cs.frame	(revision 9748)
@@ -28,5 +28,5 @@
   /// Plugin class for HeuristicLab.Problems.ExternalEvaluation.Matlab plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Problems.ExternalEvaluation.Matlab", "3.3.8.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.ExternalEvaluation.MATLAB", "3.3.8.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.ExternalEvaluation.Matlab-3.3.dll", PluginFileType.Assembly)]
   [PluginFile("Interop.MLApp.dll",PluginFileType.Assembly)]
Index: branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/Properties/AssemblyInfo.cs.frame	(revision 9715)
+++ branches/HeuristicLab.ExternalEvaluation Scientific/HeuristicLab.Problems.ExternalEvaluation.Matlab/3.3/Properties/AssemblyInfo.cs.frame	(revision 9748)
@@ -27,5 +27,5 @@
 // associated with an assembly.
 [assembly: AssemblyTitle("HeuristicLab.Problems.ExternalEvaluation.Matlab")]
-[assembly: AssemblyDescription("HeuristicLab problems for real valued parameter optimization performed in Matlab.")]
+[assembly: AssemblyDescription("HeuristicLab problems for real valued parameter optimization performed in MATLAB.")]
 [assembly: AssemblyConfiguration("")]
 [assembly: AssemblyCompany("")]